#include <stdio.h>
#include <string.h>

int main(int argc, char **argv)
{
    FILE *infile, *outfile;
    if (argc != 3) {
        printf("usage: hex2bin infile.txt outfile.bin\n");
        return 1;
    }
    infile = fopen(argv[1],"r");
    if (!infile) {
        printf("failed opening %s\n",argv[1]);
        return 1;
    }

    outfile = fopen(argv[2],"wb");
    if (!outfile) {
        printf("failed opening %s\n",argv[2]);
        return 1;
    }

    while (!feof(infile)) {
        char addr[32]={0};
        unsigned int bytes[16]={0};
        unsigned char alsobytes[16]={0};
        int bytecount;
        char spaces[2];
        int nmatched=
        fscanf(infile, "%s%x%x%x%x%x%x%x%x-"
                         "%x%x%x%x%x%x%x%x%c%c%16c",
                         addr,
                         &bytes[0],&bytes[1],&bytes[2],&bytes[3],
                         &bytes[4],&bytes[5],&bytes[6],&bytes[7],
                         &bytes[8],&bytes[9],&bytes[10],&bytes[11],
                         &bytes[12],&bytes[13],&bytes[14],&bytes[15],
                         &spaces[0],&spaces[1],alsobytes);
        if (nmatched == 20) {
            unsigned int i;
            for (i = 0; i < 16; i++) {
                if (alsobytes[i] != '.' && bytes[i] != alsobytes[i]) {
                    fprintf(stderr,"mismatch at %s+%x\n",addr,i);
                    return 1;
                }
            }
            bytecount=16;
        }
        else if (nmatched - 1 > 0)
        {
            bytecount=nmatched - 1;
        }
        else break;

        {
            unsigned int i;
            unsigned char charbytes[16];
            for (i = 0; i < bytecount; i++) {
                charbytes[i]=bytes[i];
            }
            if (fwrite(charbytes,1,bytecount,outfile)!=bytecount) {
                fprintf(stderr,"write error\n");
                return 1;
            }
        }
    }
}
